// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/GenericObservation.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/generic_observation__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
mrpt_msgs__msg__GenericObservation__init(mrpt_msgs__msg__GenericObservation * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    mrpt_msgs__msg__GenericObservation__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    mrpt_msgs__msg__GenericObservation__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__GenericObservation__fini(mrpt_msgs__msg__GenericObservation * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

bool
mrpt_msgs__msg__GenericObservation__are_equal(const mrpt_msgs__msg__GenericObservation * lhs, const mrpt_msgs__msg__GenericObservation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
mrpt_msgs__msg__GenericObservation__copy(
  const mrpt_msgs__msg__GenericObservation * input,
  mrpt_msgs__msg__GenericObservation * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

mrpt_msgs__msg__GenericObservation *
mrpt_msgs__msg__GenericObservation__create()
{
  mrpt_msgs__msg__GenericObservation * msg = (mrpt_msgs__msg__GenericObservation *)malloc(sizeof(mrpt_msgs__msg__GenericObservation));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__GenericObservation));
  bool success = mrpt_msgs__msg__GenericObservation__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__GenericObservation__destroy(mrpt_msgs__msg__GenericObservation * msg)
{
  if (msg) {
    mrpt_msgs__msg__GenericObservation__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__GenericObservation__Sequence__init(mrpt_msgs__msg__GenericObservation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__GenericObservation * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__GenericObservation *)calloc(size, sizeof(mrpt_msgs__msg__GenericObservation));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__GenericObservation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__GenericObservation__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__GenericObservation__Sequence__fini(mrpt_msgs__msg__GenericObservation__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__GenericObservation__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__GenericObservation__Sequence *
mrpt_msgs__msg__GenericObservation__Sequence__create(size_t size)
{
  mrpt_msgs__msg__GenericObservation__Sequence * array = (mrpt_msgs__msg__GenericObservation__Sequence *)malloc(sizeof(mrpt_msgs__msg__GenericObservation__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__GenericObservation__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__GenericObservation__Sequence__destroy(mrpt_msgs__msg__GenericObservation__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__GenericObservation__Sequence__fini(array);
  }
  free(array);
}

bool
mrpt_msgs__msg__GenericObservation__Sequence__are_equal(const mrpt_msgs__msg__GenericObservation__Sequence * lhs, const mrpt_msgs__msg__GenericObservation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!mrpt_msgs__msg__GenericObservation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
mrpt_msgs__msg__GenericObservation__Sequence__copy(
  const mrpt_msgs__msg__GenericObservation__Sequence * input,
  mrpt_msgs__msg__GenericObservation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(mrpt_msgs__msg__GenericObservation);
    mrpt_msgs__msg__GenericObservation * data =
      (mrpt_msgs__msg__GenericObservation *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!mrpt_msgs__msg__GenericObservation__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          mrpt_msgs__msg__GenericObservation__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!mrpt_msgs__msg__GenericObservation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
