// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mrpt_msgs:msg/GraphSlamStats.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__MSG__DETAIL__GRAPH_SLAM_STATS__TRAITS_HPP_
#define MRPT_MSGS__MSG__DETAIL__GRAPH_SLAM_STATS__TRAITS_HPP_

#include "mrpt_msgs/msg/detail/graph_slam_stats__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mrpt_msgs::msg::GraphSlamStats & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: nodes_total
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nodes_total: ";
    value_to_yaml(msg.nodes_total, out);
    out << "\n";
  }

  // member: edges_total
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edges_total: ";
    value_to_yaml(msg.edges_total, out);
    out << "\n";
  }

  // member: edges_icp_2d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edges_icp_2d: ";
    value_to_yaml(msg.edges_icp_2d, out);
    out << "\n";
  }

  // member: edges_icp_3d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edges_icp_3d: ";
    value_to_yaml(msg.edges_icp_3d, out);
    out << "\n";
  }

  // member: edges_odom
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edges_odom: ";
    value_to_yaml(msg.edges_odom, out);
    out << "\n";
  }

  // member: loop_closures
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "loop_closures: ";
    value_to_yaml(msg.loop_closures, out);
    out << "\n";
  }

  // member: slam_evaluation_metric
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.slam_evaluation_metric.size() == 0) {
      out << "slam_evaluation_metric: []\n";
    } else {
      out << "slam_evaluation_metric:\n";
      for (auto item : msg.slam_evaluation_metric) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mrpt_msgs::msg::GraphSlamStats & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mrpt_msgs::msg::GraphSlamStats>()
{
  return "mrpt_msgs::msg::GraphSlamStats";
}

template<>
inline const char * name<mrpt_msgs::msg::GraphSlamStats>()
{
  return "mrpt_msgs/msg/GraphSlamStats";
}

template<>
struct has_fixed_size<mrpt_msgs::msg::GraphSlamStats>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mrpt_msgs::msg::GraphSlamStats>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mrpt_msgs::msg::GraphSlamStats>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MRPT_MSGS__MSG__DETAIL__GRAPH_SLAM_STATS__TRAITS_HPP_
