// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mrpt_msgs:srv/GetCMGraph.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__SRV__DETAIL__GET_CM_GRAPH__TRAITS_HPP_
#define MRPT_MSGS__SRV__DETAIL__GET_CM_GRAPH__TRAITS_HPP_

#include "mrpt_msgs/srv/detail/get_cm_graph__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mrpt_msgs::srv::GetCMGraph_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: node_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.node_ids.size() == 0) {
      out << "node_ids: []\n";
    } else {
      out << "node_ids:\n";
      for (auto item : msg.node_ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mrpt_msgs::srv::GetCMGraph_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mrpt_msgs::srv::GetCMGraph_Request>()
{
  return "mrpt_msgs::srv::GetCMGraph_Request";
}

template<>
inline const char * name<mrpt_msgs::srv::GetCMGraph_Request>()
{
  return "mrpt_msgs/srv/GetCMGraph_Request";
}

template<>
struct has_fixed_size<mrpt_msgs::srv::GetCMGraph_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mrpt_msgs::srv::GetCMGraph_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mrpt_msgs::srv::GetCMGraph_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'cm_graph'
#include "mrpt_msgs/msg/detail/network_of_poses__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mrpt_msgs::srv::GetCMGraph_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cm_graph
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cm_graph:\n";
    to_yaml(msg.cm_graph, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mrpt_msgs::srv::GetCMGraph_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mrpt_msgs::srv::GetCMGraph_Response>()
{
  return "mrpt_msgs::srv::GetCMGraph_Response";
}

template<>
inline const char * name<mrpt_msgs::srv::GetCMGraph_Response>()
{
  return "mrpt_msgs/srv/GetCMGraph_Response";
}

template<>
struct has_fixed_size<mrpt_msgs::srv::GetCMGraph_Response>
  : std::integral_constant<bool, has_fixed_size<mrpt_msgs::msg::NetworkOfPoses>::value> {};

template<>
struct has_bounded_size<mrpt_msgs::srv::GetCMGraph_Response>
  : std::integral_constant<bool, has_bounded_size<mrpt_msgs::msg::NetworkOfPoses>::value> {};

template<>
struct is_message<mrpt_msgs::srv::GetCMGraph_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<mrpt_msgs::srv::GetCMGraph>()
{
  return "mrpt_msgs::srv::GetCMGraph";
}

template<>
inline const char * name<mrpt_msgs::srv::GetCMGraph>()
{
  return "mrpt_msgs/srv/GetCMGraph";
}

template<>
struct has_fixed_size<mrpt_msgs::srv::GetCMGraph>
  : std::integral_constant<
    bool,
    has_fixed_size<mrpt_msgs::srv::GetCMGraph_Request>::value &&
    has_fixed_size<mrpt_msgs::srv::GetCMGraph_Response>::value
  >
{
};

template<>
struct has_bounded_size<mrpt_msgs::srv::GetCMGraph>
  : std::integral_constant<
    bool,
    has_bounded_size<mrpt_msgs::srv::GetCMGraph_Request>::value &&
    has_bounded_size<mrpt_msgs::srv::GetCMGraph_Response>::value
  >
{
};

template<>
struct is_service<mrpt_msgs::srv::GetCMGraph>
  : std::true_type
{
};

template<>
struct is_service_request<mrpt_msgs::srv::GetCMGraph_Request>
  : std::true_type
{
};

template<>
struct is_service_response<mrpt_msgs::srv::GetCMGraph_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MRPT_MSGS__SRV__DETAIL__GET_CM_GRAPH__TRAITS_HPP_
