// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/GraphConstraint.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/graph_constraint__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `constraint`
#include "geometry_msgs/msg/detail/pose_with_covariance__functions.h"

bool
mrpt_msgs__msg__GraphConstraint__init(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (!msg) {
    return false;
  }
  // node_id_from
  // node_id_to
  // constraint
  if (!geometry_msgs__msg__PoseWithCovariance__init(&msg->constraint)) {
    mrpt_msgs__msg__GraphConstraint__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__GraphConstraint__fini(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (!msg) {
    return;
  }
  // node_id_from
  // node_id_to
  // constraint
  geometry_msgs__msg__PoseWithCovariance__fini(&msg->constraint);
}

bool
mrpt_msgs__msg__GraphConstraint__are_equal(const mrpt_msgs__msg__GraphConstraint * lhs, const mrpt_msgs__msg__GraphConstraint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // node_id_from
  if (lhs->node_id_from != rhs->node_id_from) {
    return false;
  }
  // node_id_to
  if (lhs->node_id_to != rhs->node_id_to) {
    return false;
  }
  // constraint
  if (!geometry_msgs__msg__PoseWithCovariance__are_equal(
      &(lhs->constraint), &(rhs->constraint)))
  {
    return false;
  }
  return true;
}

bool
mrpt_msgs__msg__GraphConstraint__copy(
  const mrpt_msgs__msg__GraphConstraint * input,
  mrpt_msgs__msg__GraphConstraint * output)
{
  if (!input || !output) {
    return false;
  }
  // node_id_from
  output->node_id_from = input->node_id_from;
  // node_id_to
  output->node_id_to = input->node_id_to;
  // constraint
  if (!geometry_msgs__msg__PoseWithCovariance__copy(
      &(input->constraint), &(output->constraint)))
  {
    return false;
  }
  return true;
}

mrpt_msgs__msg__GraphConstraint *
mrpt_msgs__msg__GraphConstraint__create()
{
  mrpt_msgs__msg__GraphConstraint * msg = (mrpt_msgs__msg__GraphConstraint *)malloc(sizeof(mrpt_msgs__msg__GraphConstraint));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__GraphConstraint));
  bool success = mrpt_msgs__msg__GraphConstraint__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__GraphConstraint__destroy(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (msg) {
    mrpt_msgs__msg__GraphConstraint__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__GraphConstraint__Sequence__init(mrpt_msgs__msg__GraphConstraint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__GraphConstraint * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__GraphConstraint *)calloc(size, sizeof(mrpt_msgs__msg__GraphConstraint));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__GraphConstraint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__GraphConstraint__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__GraphConstraint__Sequence__fini(mrpt_msgs__msg__GraphConstraint__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__GraphConstraint__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__GraphConstraint__Sequence *
mrpt_msgs__msg__GraphConstraint__Sequence__create(size_t size)
{
  mrpt_msgs__msg__GraphConstraint__Sequence * array = (mrpt_msgs__msg__GraphConstraint__Sequence *)malloc(sizeof(mrpt_msgs__msg__GraphConstraint__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__GraphConstraint__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__GraphConstraint__Sequence__destroy(mrpt_msgs__msg__GraphConstraint__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__GraphConstraint__Sequence__fini(array);
  }
  free(array);
}

bool
mrpt_msgs__msg__GraphConstraint__Sequence__are_equal(const mrpt_msgs__msg__GraphConstraint__Sequence * lhs, const mrpt_msgs__msg__GraphConstraint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!mrpt_msgs__msg__GraphConstraint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
mrpt_msgs__msg__GraphConstraint__Sequence__copy(
  const mrpt_msgs__msg__GraphConstraint__Sequence * input,
  mrpt_msgs__msg__GraphConstraint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(mrpt_msgs__msg__GraphConstraint);
    mrpt_msgs__msg__GraphConstraint * data =
      (mrpt_msgs__msg__GraphConstraint *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!mrpt_msgs__msg__GraphConstraint__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          mrpt_msgs__msg__GraphConstraint__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!mrpt_msgs__msg__GraphConstraint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
