// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mrpt_msgs:msg/ObservationRangeBeacon.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEACON__TRAITS_HPP_
#define MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEACON__TRAITS_HPP_

#include "mrpt_msgs/msg/detail/observation_range_beacon__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'sensor_pose_on_robot'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'sensed_data'
#include "mrpt_msgs/msg/detail/single_range_beacon_observation__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mrpt_msgs::msg::ObservationRangeBeacon & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: sensor_pose_on_robot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_pose_on_robot:\n";
    to_yaml(msg.sensor_pose_on_robot, out, indentation + 2);
  }

  // member: min_sensor_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_sensor_distance: ";
    value_to_yaml(msg.min_sensor_distance, out);
    out << "\n";
  }

  // member: max_sensor_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_sensor_distance: ";
    value_to_yaml(msg.max_sensor_distance, out);
    out << "\n";
  }

  // member: sensor_std_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_std_range: ";
    value_to_yaml(msg.sensor_std_range, out);
    out << "\n";
  }

  // member: sensed_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.sensed_data.size() == 0) {
      out << "sensed_data: []\n";
    } else {
      out << "sensed_data:\n";
      for (auto item : msg.sensed_data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mrpt_msgs::msg::ObservationRangeBeacon & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mrpt_msgs::msg::ObservationRangeBeacon>()
{
  return "mrpt_msgs::msg::ObservationRangeBeacon";
}

template<>
inline const char * name<mrpt_msgs::msg::ObservationRangeBeacon>()
{
  return "mrpt_msgs/msg/ObservationRangeBeacon";
}

template<>
struct has_fixed_size<mrpt_msgs::msg::ObservationRangeBeacon>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mrpt_msgs::msg::ObservationRangeBeacon>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mrpt_msgs::msg::ObservationRangeBeacon>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEACON__TRAITS_HPP_
