// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from mrpt_msgs:msg/ObservationRangeBearing.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEARING__STRUCT_H_
#define MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEARING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'sensor_pose_on_robot'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'sensed_data'
#include "mrpt_msgs/msg/detail/single_range_bearing_observation__struct.h"

// Struct defined in msg/ObservationRangeBearing in the package mrpt_msgs.
typedef struct mrpt_msgs__msg__ObservationRangeBearing
{
  std_msgs__msg__Header header;
  geometry_msgs__msg__Pose sensor_pose_on_robot;
  double min_sensor_distance;
  double max_sensor_distance;
  double sensor_std_range;
  double sensor_std_yaw;
  double sensor_std_pitch;
  mrpt_msgs__msg__SingleRangeBearingObservation__Sequence sensed_data;
} mrpt_msgs__msg__ObservationRangeBearing;

// Struct for a sequence of mrpt_msgs__msg__ObservationRangeBearing.
typedef struct mrpt_msgs__msg__ObservationRangeBearing__Sequence
{
  mrpt_msgs__msg__ObservationRangeBearing * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} mrpt_msgs__msg__ObservationRangeBearing__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MRPT_MSGS__MSG__DETAIL__OBSERVATION_RANGE_BEARING__STRUCT_H_
