// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mrpt_msgs:msg/SingleObjectObservation.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__MSG__DETAIL__SINGLE_OBJECT_OBSERVATION__TRAITS_HPP_
#define MRPT_MSGS__MSG__DETAIL__SINGLE_OBJECT_OBSERVATION__TRAITS_HPP_

#include "mrpt_msgs/msg/detail/single_object_observation__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'pose_wo'
// Member 'pose_so'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mrpt_msgs::msg::SingleObjectObservation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "range: ";
    value_to_yaml(msg.range, out);
    out << "\n";
  }

  // member: yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw: ";
    value_to_yaml(msg.yaw, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: pose_wo
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_wo:\n";
    to_yaml(msg.pose_wo, out, indentation + 2);
  }

  // member: pose_so
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_so:\n";
    to_yaml(msg.pose_so, out, indentation + 2);
  }

  // member: shape_variables
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.shape_variables.size() == 0) {
      out << "shape_variables: []\n";
    } else {
      out << "shape_variables:\n";
      for (auto item : msg.shape_variables) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    value_to_yaml(msg.id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mrpt_msgs::msg::SingleObjectObservation & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mrpt_msgs::msg::SingleObjectObservation>()
{
  return "mrpt_msgs::msg::SingleObjectObservation";
}

template<>
inline const char * name<mrpt_msgs::msg::SingleObjectObservation>()
{
  return "mrpt_msgs/msg/SingleObjectObservation";
}

template<>
struct has_fixed_size<mrpt_msgs::msg::SingleObjectObservation>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mrpt_msgs::msg::SingleObjectObservation>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mrpt_msgs::msg::SingleObjectObservation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MRPT_MSGS__MSG__DETAIL__SINGLE_OBJECT_OBSERVATION__TRAITS_HPP_
